<?php

class Expresso {

	protected $expressoVersion;
	protected $ldapCatalog;
	var $result;
	var $error;
	var $id;

	
	function __construct($id){		
		$this->expressoVersion = substr($GLOBALS['phpgw_info']['server']['versions']['phpgwapi'],0,3);
		$this->result 	= null;
		$this->error 	= null;						
		$this-> id 		= $id;
	}

	protected function getResponse(){	
		return  array(
				'result'	=> $this->result,
				'error'		=> $this->error,
				'id'		=> $this->id
		);
	}	
		
	protected function getUserId(){
		return $GLOBALS['phpgw_info']['user']['account_id'];
	}
	
	protected function getLdapCatalog(){
		if(!$this->ldapCatalog) {
			$catalog_config = CreateObject("contactcenter.bo_ldap_manager");
			$_SESSION['phpgw_info']['expressomail']['ldap_server'] = $catalog_config ? $catalog_config->srcs[1] : null;
			$this->ldapCatalog = CreateObject("expressoMail1_2.ldap_functions");
		}
	
		return $this->ldapCatalog;
	}
	
	protected function getDb(){
		return $GLOBALS['phpgw']->db;
	}
	
	
	protected function isLoggedIn($params){
		list($sessionid, $kp3) = explode(":", $params['auth']);
		if($GLOBALS['phpgw']->session->verify($sessionid, $kp3)){									
			return true;
		}
		else{
			$this-> error = "You are not logged in";
			return false;
		}		
	}	
	
	public function getExpressoVersion(){		
		$this->result = array('expressoVersion' =>  $this->expressoVersion);
		return $this->getResponse();
	}
	
	public function login($params){
		if(!$this-> isLoggedIn($params)) 
		{				
			if($params['auth'] != "") 
			{	
				$this->error  = "Your auth is invalid";
				
			}
			elseif($sessionid = $GLOBALS['phpgw']->session->create($params['user'], $params['password']))					
			{
				$this->error  = null;
				$this->result = array('auth' =>  $sessionid.":".$GLOBALS['phpgw']->session->kp3);
			}
			else
			{				
				$this-> error = $GLOBALS['phpgw']->session->reason;
			}			
		}
		else
		{
			$this->result = array('auth' =>  $params['auth']);
		}
		
		return $this->getResponse();	
	}	
	
	public function logout($params){			
		
		if($this->isLoggedIn($params))
		{
			if (file_exists($GLOBALS['phpgw_info']['server']['temp_dir'].SEP.$_SESSION['phpgw_session']['session_id']))	
			{
				$dh = opendir($GLOBALS['phpgw_info']['server']['temp_dir']. SEP . $_SESSION['phpgw_session']['session_id']);
				while ($file = readdir($dh)) 
				{
					if ($file != '.' && $file != '..') 
					{
						unlink($GLOBALS['phpgw_info']['server']['temp_dir'].SEP.$_SESSION['phpgw_session']['session_id'].SEP.$file);
					}
				}
				rmdir($GLOBALS['phpgw_info']['server']['temp_dir'].SEP.$_SESSION['phpgw_session']['session_id']);
			}
			$GLOBALS['phpgw']->hooks->process('logout');
			$GLOBALS['phpgw']->session->destroy($_SESSION['phpgw_session']['session_id'], $GLOBALS['kp3']);
			$this->result = true;
		}
		
		return $this->getResponse();
	}	
}